#ifndef __OTHELLO_APP_H__
#define __OTHELLO_APP_H__

#include "AppBase.h"
#include "FKUT/TrackBall.h"
#include "FKUT/SpriteModel.h"

#include "Board.h"
#include "Stone.h"

/*
	fk_Windowɂ̓|C^drawWinANZXB
	L[͂֗̕nEventManagerNXeveMan痘płB
	ƂFKƁAFKUT̃NX⏕Iɗpď\zB
	init()update()΁A͎RɊ֐ǉĂA
	ō쐬NX𗘗p邱Ƃ\B
 */

// ɗ͐l͒萔
const int WINDOW_WIDTH = 960, WINDOW_HEIGHT = 544;

class OthelloApp : public fkut_AppBase {
public:
	OthelloApp(Fl_Window *mainWin, fk_Window *drawWin);
	~OthelloApp(void);
protected:
	// ̉ʂŕ\̂܂Ƃ߂郊Xg
	fk_Scene		scene;
	// Jƌ
	fk_Model		camera, lightModel;
	fk_Light		light;
	fk_TrackBall	tb;
	
	// Ֆ
	Board			board;
	// 
	vector<Stone *>	stoneArray;	// vectorzŐ΂Ǘ
	
	// fobO\p
	fkut_SpriteModel	textSpr;

	// (Processingsetup()ɑ)
	void init(void);
	// t[̏(Processingdraw()ɑ)
	bool update(void);

	// Ֆʂ܂ޕʏ̂ǂNbN̂Ԃ֐
	fk_Vector	clickProc(void);
	// ΂w肵ꏊɐ鏈(constQƂ𗘗p)
	int			makeStone(const fk_Vector &pos);

	// t@CǂݏTv
	bool		saveState(void);
	bool		loadState(void);

	// ̃bZ[Wo͂֐
	void		putMessage(string text);
};

#endif
